//****************************************************************************************************
//****************************************************************************************************
// -Butler main
// all rights itm-praktiker
// www.praktiker.at
//
// enthlt i/o-function
// Datum: 05/06/2005
// Rev.:00
//
//  Compiler options: Strings in flash only, small model of printf, 8515
//
//  Revision history:
//
//****************************************************************************************************
//****************************************************************************************************

// Target: AT90S8535

#include <io8535v.h>
#include <macros.h>
#include "PIr_BaseType.h"
#include "PIr_Prot.h"

//------------------------------------------------------------------------------------------------------------
//Globals
volatile unsigned int   gl_IR_pulsewidth=0;       //contains the measured pulse width of the start bit of an IR-word
volatile unsigned char  gl_IR_bitcnt=0;           //14 bit is a complete word
volatile unsigned int   gl_IR_rec_word=0;         //the received code word
volatile unsigned int   gl_IR_1st_rec_word=0;     //the first received code word, to defetch bad codes
volatile unsigned char  gl_IR_tm_out=0;           //Timeout register for IR-word receive
volatile unsigned char  gl_T0_aux_1;
volatile unsigned char  gl_T0_wait=0;             //Wartezeit vor dem Demuten

volatile UInt8	T0_Var1=0;

volatile unsigned int  gl_IR_word=0;
volatile unsigned int  gl_IR_last_Command=0;
volatile unsigned char gl_IR_toggle=0;
volatile unsigned char gl_IR_last_toggle=0;
volatile unsigned char gl_Timer0_10msec=10;
volatile unsigned char gl_Timer0_40msec=40;
volatile unsigned char gl_Timer0_100msec=100;

//unsigned char gl_Timer0_Test_lock=0;              // Test CS8420-Lock
volatile unsigned char gl_TIRWait=0;
volatile unsigned char gl_TComExt=0;



UInt8 init_tab[] = {
  FUNCTION_SET,
  LCD_CLEAR,
  LCD_OFF,
  LCD_ON,
  LCD_CLEAR
};

const UInt8 headline1[]="    IR-VIEW     ";


//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------



//------------------------------------------------------------------------------------------------------------
/* Timer 0 will be used as general purpose 1 msec. timer, servicing several time registers
*/
#pragma interrupt_handler timer0_ovf_isr:10
void timer0_ovf_isr(void)  /* */
{
 unsigned char c_var1=0;

 TCNT0 = 0x83; //reload counter value, 1 msec. rate

 /*-------------------------------------------------*/
 /*-------------------------------------------------*/
 /* 1 msec. timer ab hier hinzufgen ----------------- */
 if(gl_IR_tm_out)
  --gl_IR_tm_out;

 if(T0_Var1)
  -- T0_Var1;

 if(gl_T0_wait)
  gl_T0_wait--;

 /* Ende 1 ms. timer -------------------------------*/
 /*-------------------------------------------------*/
 /* 10 msec. Cascade */
 if(gl_Timer0_10msec)
  gl_Timer0_10msec--;
 else {
  gl_Timer0_10msec=10;
  /* 10 msec. timer ab hier hinzufgen ----------------- */


  if(gl_T0_aux_1)
    gl_T0_aux_1--;


 /* Ende 10 ms. timer -------------------------------*/
 }
 /*-------------------------------------------------*/
 /* 40 msec. Cascade */
 if(gl_Timer0_40msec)
  gl_Timer0_40msec--;
 else {
  gl_Timer0_40msec=40;
  /* 40 msec. timer ab hier hinzufgen ----------------- */



  /* Ende 40 ms. timer -------------------------------*/
 }
 /*-------------------------------------------------*/
 /* 100 msec. Cascade */
 if(gl_Timer0_100msec)
  gl_Timer0_100msec--;
 else {
  gl_Timer0_100msec=100;
  /* 100 msec. timer ab hier hinzufgen ----------------- */

  if(gl_TIRWait)
    gl_TIRWait--;

  if(gl_TComExt)
    gl_TComExt--;

  /* Ende 100 ms. timer -------------------------------*/
 }
}

/**********************************************************************/
/**********************************************************************/

//------------------------------------------------------------------------------------------------------------
#pragma interrupt_handler timer1_ovf_isr:9
void timer1_ovf_isr(void)
{

  TCNT1=gl_IR_pulsewidth;   //reload timer with the first measured time width
  /* Shift level of IR-receiver to receivebuffer */
  /* Manchester- or Biphasecode: rising edge==1, falling edge==0;
  ** Instead of the edge the level will be tested within the time between the first two
  ** start bits and within an initial time offset
  */

  if(gl_IR_bitcnt<14){
    gl_IR_rec_word<<=1;
    /* Abfrage des IR-Pegels */
    if(PIND&0x04) {
      gl_IR_rec_word+=1;    //set lsb else do nothing because filled with 0 during shift left
    }
    ++gl_IR_bitcnt;
  }
  /* Word complete, copy and initialize */
  else {
    if(gl_IR_1st_rec_word!=gl_IR_rec_word) {
      gl_IR_1st_rec_word=gl_IR_rec_word;
      gl_IR_word=0;
      return;
    }
    else {
      gl_IR_word=gl_IR_rec_word;
      gl_IR_1st_rec_word=0;
    }

    /**********************************************************************/
    /**********************************************************************/
    /* Applikation: hier werden IR-Aktionen eingefgt                  ****/
    /**********************************************************************/

    gl_IR_last_Command=gl_IR_word&0x07FF;    //nur Adress und Datenbits, Togglebit wird ausgeblendet

    //Auswahl der Adresse als ersten Schritt
    // Taste '1'
    if ((gl_IR_word&0x07FF)==0x7FE) {
    }

    /**********************************************************************/
    FINISH_IR:
    /**********************************************************************/
    /**********************************************************************/

    if(gl_IR_word&0x0800)
      gl_IR_toggle=1;
    else
      gl_IR_toggle=0;

    gl_IR_rec_word=0;
    gl_IR_bitcnt=0;
    gl_IR_tm_out=0;          //30 msec. RC5-timeout, complete word ~25msec.

    gl_TIRWait=TIRWAIT;
    gl_TComExt=TCOMEXT;

    MCUCR =  0x0E;            //Int0 falling edge, Int1 rising edge, external SRAM disabled !Debug!
    TIMSK &= 0xC1;            //Timer 1 Overflow Int disabled, Timer 0+2 unchanged
    TCCR1B = 0x00;            //stopTimer CLK=1/8, frequency = 0Hz

    gl_IR_word=0;
  }
}


//------------------------------------------------------------------------------------------------------------
#pragma interrupt_handler uart0_rx_isr:12
void uart0_rx_isr(void)  /* */
{
 //uart has received a character in UDR
}

//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
#pragma interrupt_handler int0_isr:2
void int0_isr(void)  /* */
{
 //external interupt on INT0
 //if time out register expired all regs will be cleared
 /* Initialize a new RC5-word */
 /* Corresponding Timer: TIMER 1 */
 unsigned int w_var1;

 if(gl_IR_tm_out==ZERO) {
  gl_IR_pulsewidth=0;       //contains the measured pulse width of the start bit of an IR-word
  gl_IR_rec_word=0;         //the received code word
  gl_IR_bitcnt=1;           //14 bit is a complete word
  gl_IR_tm_out=30;          //30 msec. RC5-timeout, complete word ~25msec.

  TCNT1 = 0x00              /*Initial setting*/; //reload counter high value
  TIMSK &= 0xC1;            //Timer 1 Overflow Int disabled, Timer 0+2 unchanged
  TCCR1B = 0x02;            //Run Timer CLK=1/8, frequency = 0Hz
  MCUCR = 0x0E;             //Int0 falling edge, Int1 rising edge, external SRAM disabled !Debug!

 }
 /* Startbit width already measured, and copied as reload value */
 /* First bit will be measured with quarter offset + pulsewidth */
 else if(gl_IR_bitcnt==1){
  TCCR1B = 0x00;            //Stop Timer CLK=1/8, frequency = 0Hz
  if(TCNT1>1000) {
    gl_IR_pulsewidth=(0xFFFF-TCNT1); //~1.7 msec
    TCNT1=gl_IR_pulsewidth+(TCNT1>>2); //Mit einem 1/4-Offset beginnen
    TIMSK |= 0x04;            //Timer 1 Overflow Int enabled, Timer 0 unchanged
    TIFR |= 0X04;             //Timer 1 Clear interrupt flag
    TCCR1B = 0x02;            //run Timer CLK=1/8, frequency = 1/gl_IR_pulsewidth
    ++gl_IR_bitcnt;
  }
  else {

    /* Neuinitialisierung wegen Fehlmessung */
    gl_IR_pulsewidth=0;       //contains the measured pulse width of the start bit of an IR-word
    gl_IR_rec_word=0;
    gl_IR_bitcnt=0;
    gl_IR_tm_out=0;          //30 msec. RC5-timeout, complete word ~25msec.

    gl_TIRWait=0;
    gl_TComExt=0;

    TIMSK &= 0xC1;            //Timer 1 Overflow Int disabled, Timer 0 overflow Int enabled
    TCCR1B = 0x00;            //stopTimer CLK=1/8, frequency = 0Hz


  }
 }
}

//------------------------------------------------------------------------------------------------------------
#pragma interrupt_handler int1_isr:3
void int1_isr(void) /* */
{

}




//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
void main(void)  /* */
{
  //Setup CPU internals
  init_devices();


 //============================================================================

  //============================================================================
  // EEPROM-Parameter laden
  // Parameter des EEPROM, wenn sich an den ersten 5 Bytes nicht das Testmuster
  // findet, wird neu mit Defaults initialisiert.



/**********************************************************************************************************************************/
/**********************************************************************************************************************************/
/**********************************************************************************************************************************/

  LCD_reset();
  LCD_init();
  /* switch LCD-Backlight on */
  LCD_LED(ON);

  LCD_command(LCD_CURSOR_OFF);
  LCD_command(LCD_HOME);
  LCD_command(LCD_CLEAR);
  LCD_puts_const(headline1);
  gl_T0_aux_1=20; while(gl_T0_aux_1);
  LCD_command(LCD_HOME);
  LCD_command(LCD_CLEAR);

  while(1){

    if(gl_IR_last_Command) {
      LCD_command(LCD_HOME);
      LCD_puts("IR: Adr: 0x");
      write_2dig_hex_to_LCD((gl_IR_last_Command>>6)&0x001F);
      LCD_puts("\nIR: Bef: 0x");
      write_2dig_hex_to_LCD(gl_IR_last_Command&0x003F);
    }

  }
}
